#
# Copyright (c) 2003 Linuxant inc.
#
# NOTE: The use and distribution of this software is governed by the terms in
# the file LICENSE, which is included in the package. You must read this and
# agree to these terms before using or distributing this software.
#

# set _target_kernel to generic if it wasn't defined on the command-line
%if %{expand:%{?_target_kernel:0}%{!?_target_kernel:1}}
%define _target_kernel generic
%endif

%if "%{_target_kernel}" == "generic"
%define ver      1.45
%define rel      1
%define automrecomp 1
%else
%define ver      1.45_k%(eval echo %{_target_kernel} | sed 's/-/_/g')
%define rel      1%{_target_distro}
%define automrecomp 0
%endif

%define dldrdesc    Linuxant DriverLoader for Wireless LAN devices
%define dldrname    driverloader
%define dldrabbr    dldr

# Note that this is NOT a relocatable package

%define dldretcdir /etc/driverloader
%define dldrlibdir /usr/lib/driverloader
%define dldrvardir /var/lib/driverloader

# Even though newer versions of RPM provide definitions for these,
# we must still accomodate the older ones
%define prefix   /usr
%define etcdir   /etc
%define libdir   %{prefix}/lib
%define sbindir  %{prefix}/sbin
%define bindir   %{prefix}/bin

Summary:   %{dldrdesc}
Name:      %{dldrname}
ExclusiveOS: Linux
%if "%{_target_kernel}" == "generic"
ExclusiveArch: athlon i686 i586 i486 i386
%else
ExclusiveArch: %{_target_cpu}
%endif
Version:   %ver
Release:   %rel
Vendor:	   Linuxant
Copyright: Copyright (c) 2003 Linuxant inc. All rights reserved.
Group:     System Environment/Kernel
Source:    %{dldrname}-1.45.tar.gz
URL:       http://www.linuxant.com/
BuildRoot: %{_tmppath}/%{dldrname}-%{PACKAGE_VERSION}-root
Packager:  Linuxant
Requires:  wireless-tools
%if %{automrecomp}
Requires:  kernel-source
Requires:  gcc
%endif
Conflicts: bcmwl5driverloader
Autoreq:   0

%description
%{dldrdesc}

Copyright (c) 2003 Linuxant inc.

1.   Permitted use. Redistribution and use in source and binary forms,
without modification, are only permitted under the terms set forth herein.

2.   Disclaimer of Warranties. LINUXANT, ITS SUPPLIERS, AND OTHER CONTRIBUTORS
MAKE NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
LINUXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD
TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.

This software has not been formally tested, and there is no guarantee that
it is free of errors including, but not limited to, bugs, defects,
interrupted operation, or unexpected results. Any use of this software is
at user's own risk.

3.   No Liability.

(a) Linuxant, its suppliers, or contributors shall not be responsible for
any loss or damage to users, customers, or any third parties for any reason
whatsoever, and LINUXANT, ITS SUPPLIERS OR CONTRIBUTORS SHALL NOT BE LIABLE
FOR ANY ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR
CONSEQUENTIAL (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

(b) User agrees to hold Linuxant, its suppliers, and contributors harmless
from any liability, loss, cost, damage or expense, including attorney's fees,
as a result of any claims which may be made by any person, including
but not limited to User, its agents and employees, its customers, or
any third parties that arise out of or result from the manufacture,
delivery, actual or alleged ownership, performance, use, operation
or possession of the software furnished hereunder, whether such claims
are based on negligence, breach of contract, absolute liability or any
other legal theory.

4.   Notices. User hereby agrees not to remove, alter or destroy any
copyright, trademark, credits, other proprietary notices or confidential
legends placed upon, contained within or associated with the Software,
and shall include all such unaltered copyright, trademark, credits,
other proprietary notices or confidential legends on or in every copy of
the Software.

5.   Reverse-engineering. User hereby agrees not to reverse engineer,
decompile, or disassemble the portions of this software provided solely
in object form, nor attempt in any manner to obtain their source-code.

6.   Redistribution. Redistribution of this software is only permitted
for exact copies (without modification) of versions explicitly marked
and officially released by Linuxant with the word "free" in their name.
Redistribution or disclosure of other versions, derivatives or license key
information is expressly prohibited without explicit written approval signed
by an authorized Linuxant officer.

7.   Performance. Actual speeds vary and are often less than the maximum
possible.


%prep
%setup -q -n %{dldrname}-1.45

%build

make --quiet --no-print-directory all

%if "%{_target_kernel}" == "generic"

%else

%if "%{_target_distro}" == "rh"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" DLDR_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "mdk"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" DLDR_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
		ln -s i586 binaries/i686
		ln -s i586 binaries/athlon
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "suse"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} DLDR_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
%if "%{_target_cpu}" == "i586"
		for a in i686 athlon; do
%else
		for a in i386 i486 i586 i686 athlon; do
%endif
			[ -e binaries/$a ] || ln -s %{_target_cpu} binaries/$a
		done
	fi
) || exit $?
%endif

%endif

%install
rm -rf $RPM_BUILD_ROOT

make --quiet --no-print-directory ROOT=$RPM_BUILD_ROOT install

#( cd $RPM_BUILD_ROOT%{dldretcdir}/config && cd .. && tar czf config.tar.gz config && rm -rf config/*)

%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(0555, root, root, 755)

%{sbindir}/%{dldrabbr}config
%{sbindir}/%{dldrabbr}stop
%{sbindir}/%{dldrabbr}infparse
# convenience symlinks to sbin:
%{bindir}/%{dldrabbr}config
%{bindir}/%{dldrabbr}stop

%dir %{dldrlibdir}
%{dldrlibdir}/webconfd

%dir %{dldrlibdir}/webconfdocs
%dir %{dldrlibdir}/webconfdocs/cgi-bin
%{dldrlibdir}/webconfdocs/cgi-bin/*.cgi

%defattr(0444, root, root, 755)
%dir %{dldretcdir}
%dir %{dldretcdir}/config
%dir %{dldretcdir}/static
%{dldretcdir}/static/webconf
%{dldrlibdir}/webconfd.conf
%{dldrlibdir}/webconfdocs/.htaccess
%{dldrlibdir}/webconfdocs/*.*html
%{dldrlibdir}/webconfdocs/includes
%{dldrlibdir}/webconfdocs/images
%{dldrlibdir}/webconfdocs/cgi-bin/.htaccess
%{dldrlibdir}/dldrparser.pm
%doc %{dldrlibdir}/LICENSE
%dir %{dldrlibdir}/modules
%dir %{dldrlibdir}/modules/GPL
%doc %{dldrlibdir}/modules/GPL/COPYING
%{dldrlibdir}/modules/binaries
%dir %{dldrvardir}

%if %{automrecomp}
%config %{dldrlibdir}/config.mak
%{dldrlibdir}/modules/imported
%attr(755, root, root) %{dldrlibdir}/modules/*.sh
%{dldrlibdir}/modules/Makefile
%{dldrlibdir}/modules/*.c
%{dldrlibdir}/modules/GPL/*.c
%{dldrlibdir}/modules/GPL/*.h
%dir %{dldrlibdir}/modules/include
%{dldrlibdir}/modules/include/*.h
%endif

%doc BUGS CHANGES CREDITS FAQ INSTALL LICENSE README

%pre
if [ "$1" = 1 ]; then
	if [ -e "%{dldretcdir}/config" ]; then
		echo "Removing old %{dldretcdir}/config"
		rm -rf "%{dldretcdir}/config"
	fi
	if [ -e "%{dldrlibdir}" ]; then
		echo "Removing old %{dldrlibdir}"
		rm -rf "%{dldrlibdir}"
	fi
fi
exit 0

%post

#if [ -f %{dldretcdir}/config.tar.gz ]; then
#	( cd %{dldretcdir} && tar xzf config.tar.gz )
#fi

#%if ! %{automrecomp}
DLDR_AUTOCONFIG=true
#%endif

DLDRHELPERACTION=stop %{dldrlibdir}/webconfd
%{sbindir}/%{dldrabbr}stop

if [ -n "${DLDR_AUTOCONFIG}" -a -z "${DLDR_NOAUTOCONFIG}" ]; then
	%{sbindir}/%{dldrabbr}config --auto
	exit $?
else
	echo "To complete the installation and configuration of your device,"
	echo "please run \"%{dldrabbr}config\" (or \"%{sbindir}/%{dldrabbr}config\")"
	exit 0
fi

%preun
%{sbindir}/%{dldrabbr}stop
DLDRHELPERACTION=stop %{dldrlibdir}/webconfd
if [ "$1" = 0 ]; then

	if [ -z "${DLDR_NOAUTOCONFIG}" ]; then
		%{sbindir}/%{dldrabbr}config --remove
	fi

#	if [ -f %{dldretcdir}/config.tar.gz ]; then
#		( cd %{dldretcdir} && rm -rf `tar tzf %{dldretcdir}/config.tar.gz | egrep '^config/[^/]+/?$'` )
#	fi
else
	exit 0
fi

# This must be last since the file CHANGES is automatically appended
%changelog

* Thu Nov 20 2003 -
	- Changed 127.1 to 127.0.0.1 since some browsers do not recognize
	the abbreviated IP address syntax.
	- Improved integration with SuSE's YaST.
	- Fixed INF issue with CopyFiles.

* Mon Nov 17 2003 -
	- Released driverloader-1.44.

* Mon Nov 17 2003 -
	- Added dldrconfig --webconf option to change the web configurator's
	listening address (now 127.1:18020 by default) or disable it completely.
	- Fixed INF parsing issue affecting Proxim/ORiNOCO 802.11abg driver.

* Sun Nov 16 2003 -
	- Released driverloader-1.43.

* Sun Nov 16 2003 -
	- Fixed issues affecting Realtek RTL8180L (Netgear MA521) and
	Intersil drivers.
	- WEP fine-tuning.

* Fri Nov 14 2003 -
	- Released driverloader-1.42.

* Fri Nov 14 2003 -
	- Fixed INF parsing issue which affected Intersil Driver for
	3COM OfficeConnect Wireless 11g Cards.
	- Fixed 64-bit arithmetic shift functions.
	- Added missing functions for some ACX100 drivers.

* Thu Nov 13 2003 -
	- Released driverloader-1.41.

* Thu Nov 13 2003 -
	- Improved timer, thread, and init/halt procedures.
	- Fixed subtle WEP issue causing "netndis_xmitcomplete_handler: err -5".
	- Fixed minor transmit issue with serialized drivers (Atheros).

* Wed Nov 12 2003 -
	- Released driverloader-1.40.

* Wed Nov 12 2003 -
	- Fixed irq synchronization problem.
	- Fixed packet flow suspension after temporary link interruption
	(such as when client leaves AP range and later comes back to reassociate).
	- Fixed multicast issues and re-enabled netndis_set_multicast_list().
	- dldrconfig --remove now deletes driverloader kernel module from all
	/lib/modules/*/misc directories (not just current one) but not the contents
	of /var/lib/driverloader/ so as to preserve drivers across upgrades.
	- Merged kcompat.h into oscompat.h and removed extraneous stuff.

* Wed Nov 12 2003 -
	- Released driverloader-1.39.

* Wed Nov 12 2003 -
	- Fixed issue with regParmUsed() causing crashes on kernels
	built without CONFIG_FRAME_POINTER.
	- Implemented legacy functions Hal[Get|Set]BusData[ByOffset]()
	still needed by some Atheros drivers.
	- Documented that newer versions of the bcmwl5.sys Broadcom driver
	solve WEP problems sometimes seen with BCM4301 used in cards like
	the Linksys WMP11 2.7, Dell TrueMobile 1180 MiniPCI and others.

* Mon Nov 10 2003 -
	- Released driverloader-1.38.

* Mon Nov 10 2003 -
	- Fixed minor issue with NdisMQueryAdapterResources().
	- Added obsolete NdisMPciAssignResources(), which some drivers still need.
	- Fixed bug causing init process to consume 100% of CPU under 2.6.0-test.
	- Silenced "probe of [device] failed with error -5" messages.

* Sun Nov 09 2003 -
	- Released driverloader-1.37.

* Sun Nov 09 2003 -
	- Added workaround for INFs in unicode format (such as the ones supplied
	with RavoTek W54-CB and W54-PCI cards).

* Sun Nov 09 2003 -
	- Released driverloader-1.36.

* Sun Nov 09 2003 -
	- Updated FAQ.

* Sat Nov 08 2003 -
	- Released driverloader-1.35.

* Sat Nov 08 2003 -
	- Fixed some issues affecting 2.6.0-test kernels
	- Revised thread concept.
	- Various small improvements.

* Fri Nov 07 2003 -
	- Released driverloader-1.34.

* Fri Nov 07 2003 -
	- Improved shutdown procedure.

* Fri Nov 07 2003 -
	- Released driverloader-1.33.

* Fri Nov 07 2003 -
	- Revised locking scheme to avoid EBUSY.
	- Tweaked module configuration in dldrconfig.
	- Fixed "cannot schedule task" during shutdown.
	- Temporarily disabled netndis_set_multicast_list() until some issues
	are resolved.

* Fri Nov 07 2003 -
	- Released driverloader-1.32.

* Fri Nov 07 2003 -
	- Eliminated cause of remaining mmu_cr4_features cases.

* Fri Nov 07 2003 -
	- Released driverloader-1.31.

* Fri Nov 07 2003 -
	- Added workaround for mmu_cr4_features problem with some kernels.

* Fri Nov 07 2003 -
	- Released driverloader-1.30.

* Fri Nov 07 2003 -
	- Major stability improvements.
	- Fixed free_netdev() issue with Fedora kernel.

* Mon Nov 03 2003 -
	- Released driverloader-1.25.

* Mon Nov 03 2003 -
	- Made INF matching always case-insensitive.
	- "iwconfig netif key [key] open|restricted" now sets authentication mode.
	- "iwconfig netif rate <speed>" now sets desired speed if supported.
	- Changed default netif name prefix from "eth" to "wlan" under SuSE 9.0.
	- Revamped device selection, added --netdevname option, and removed unused
	code in dldrconfig.
	- Fixed more WEP issues.
	- Enabled NDIS error code decoding.
	- Added missing functions for some Atheros driver variants.
	- Successfully tested with Cisco Aironet 352 MiniPCI card in
	IBM Thinkpad T40 notebook after tweaking NdisMRegisterIoPortRange()
	and installing version 3.4.9 of the Windows driver.
	(Thanks to Nickolai Zeldovich)

* Sat Nov 01 2003 -
	- Released driverloader-1.24.

* Sat Nov 01 2003 -
	- Fixed NdisWrapGetBSSIDList() bug affecting iwlist accesspoints/scanning.
	- Fixed WEP issue with Intersil Prism GT driver.
	- Added support for Texas Instruments ACX100-based Adapters.
	(PCI ID 104C:8400 and others)
	- Added some missing functions for Cisco Aironet (802.11a/b) drivers.
	- Implemented proper support for NdisWriteConfiguration().
	- Improved module reference count management and time reporting.

* Thu Oct 30 2003 -
	- Released driverloader-1.23.

* Thu Oct 30 2003 -
	- Fixed INF matching issue.
	- Added [Refresh] to update page contents without reloading in webconf.
	- Implemented workaround for "OsForkWait: Waiting for pid failed (errno=1)"
	problem on SuSE 9.0.
	- Modified config script to put module aliases in
	/etc/{modules,modprobe}.conf.local if present (SuSE 9.0).
	Thanks to Johannes Endres for suggesting this.

* Thu Oct 30 2003 -
	- Released driverloader-1.22.

* Thu Oct 30 2003 -
	- Fixed locking issue that could cause occasional system hangs.
	- Fixed minor INF parsing bug.

* Wed Oct 29 2003 -
	- Implemented required functionality to support TI ACX100 drivers.

* Tue Oct 28 2003 -
	- Solved "HOSWORKSTORAGE too small" problem seen under 2.6.0-test kernels.

* Tue Oct 28 2003 -
	- Released driverloader-1.21.

* Tue Oct 28 2003 -
	- Implemented required functionality to support Realtek RTL8180L
	chipset (Tested with D-Link DWL-510 card, thanks to Adam Sjgren).
	- Corrected various INF parsing issues.
	- Added check for CONFIG_DEBUG_SPINLOCK, which we cannot support
	since it makes spinlocks and other structures containing them too large
	to fit in NDIS objects.
	- Added perl syntax check to dldrconfig to detect missing perl-CGI
	modules.

* Sun Oct 26 2003 -
	- Released driverloader-1.20.

* Sun Oct 26 2003 -
	- Reorganized package to reflect new multiple driver capabilities.
	- Fixed issues related to SuSE 9.0 and licensing.
	- Added support for Intel(R) PRO/Wireless LAN (Centrino) Adapters
	(PCI ID 8086:1043 and others)
	- Added support for Intersil Prism GT/Duette/Indigo-based Adapters
	(PCI ID 1260:3890 and others)
	- Added support for Atheros-based Adapters (PCI ID 168C:0013 and others)
	- Fixed automatic ESSID handling and suspend/resume issues.
	- modules/GPL/kcompat.h: don't provide free_netdev if HAVE_FREE_NETDEV.
	- Restructured INF parser.
	- Updated FAQ.
	- Added pre-built binary packages for Mandrake 9.2 and SuSE 9.0.
	- Numerous other improvements.

* Mon Oct 13 2003 -
	- Released bcmwl5driverloader-1.05.

* Mon Oct 13 2003 -
	- BUGS: Added note about transmit issue with some 802.11b 4301 chips, which
	should be fixed soon.

* Sat Oct 11 2003 -
	- Released bcmwl5driverloader-1.04.

* Sat Oct 11 2003 -
	- modules/GPL/netndis.c: disable WEP if not supported by card.

* Sat Oct 11 2003 -
	- Released bcmwl5driverloader-1.03.

* Sat Oct 11 2003 -
	- Added NdisTerminateWrapper().

* Sat Oct 11 2003 -
	- Released bcmwl5driverloader-1.02.

* Sat Oct 11 2003 -
	- bcmwl5/dldrpci_tbl.h, README: Added other PCI devices known to
	Broadcom's BCMWL5 driver (4301, 4307, 4325, 4321, 4324, 4311).

* Fri Oct 10 2003 -
	- Released bcmwl5driverloader-1.01.

* Fri Oct 10 2003 -
	- Silenced a few benign messages, clarified webconf help text and solved
	refresh issue when configuring without the device being present.

* Fri Oct 10 2003 -
	- Initial release (bcmwl5driverloader-1.00).
